#include <inttypes.h>
#include <iostream>
#include <unordered_map>
#include <string>
#include <fstream>
#include "Hashtable.h"
using namespace std;

unordered_map<string, uint64_t> htmap;


/*
* Get value of a key
*/
uint64_t Hashtable::get(string key) {
	try {
		return(htmap.at(key));
	}
	catch (out_of_range) {
		return(NULL);
	}
}

void Hashtable::setLoadFactor(float factor){
	htmap.max_load_factor(factor);
}

/*
* Check if key exists
* Returns 0 if no, 1 if yes
*/
int Hashtable::check(string key) {
	if (htmap.find(key) == htmap.end()) {
		return(0);
	}
	else {
		return(1);
	}
}

/*
* Counts a key one up
*/
void Hashtable::plus_one(string key) {
	try {
		htmap.at(key) += 1;
	}
	catch (out_of_range) {
		htmap.emplace(key, 1);
	}
}

/*
* Exports Hashtable as csv
* Returns 0 at success otherwise 1
*/
int Hashtable::export_table(char *filename) {
	ofstream file(filename);
	if (file.is_open())
	{
		for (auto it = htmap.begin(); it != htmap.end(); ++it) {
			file << it->first << ";" << it->second << endl;
		}
		file.close();
		return(0);
	}
	else {
		return(1);
	}
}
