#include <string>
#include "Charactertools.h"

using namespace std;

/*
* Checks if a given character marks the end of a word.
*/
int Charactertools::delimiter_character(char c) {
	if (c == ' ' || c == '.' || c == ',' || c == '!' || c == '?')
		return(1);
	else
		return(0);
}

/*
* Extracts a Ngram character wise. Returns always 0
* *mem		the memory containing the text
* offset	offset in memory address
* counter	size of the Ngram = N
* ret		the extracted Ngram
*/
int Charactertools::extract_ngram(char *mem, int offset, int counter, string &ret) {
	char c[20];
	for (int i = 0; i <= counter - 1; i++) {
		c[i] = mem[offset + i];
	}
	c[counter] = '\0';
	ret = string(c);
	return(0);
}

/*
* Extracts a word. Returns offset of new ' ' on success and 0 on failure.
* *mem		the memory containing the text
* offset	offset in memory address
* ret		the extracted Ngram
*/
int Charactertools::extract_word(char *mem, int offset, string &ret) {
	char c[20];
	int too_much = 0;
	int start = -1, stop = -1;
	int i = 0, j = 0;
	while (stop == -1) {
		if (delimiter_character(mem[offset + i])) {
			if (start == -1) {
				start = i;
			}
			else if(i-start > 1){
				stop = i;
			}
		}
		else {
			if (start != -1) {
				if (!delimiter_character(mem[offset + i])) {
					c[j] = mem[offset + i];
					j++;
				}
			}
		}
		i++;
		if (i == 20) {
			stop = 1;
			too_much = 1;
		}
	}
	c[j] = '\0';
	ret = string(c);
	if (too_much == 1) {
		return(0);
	}
	else
		return(offset + stop);
}

int Charactertools::extract_multiple_words(char *mem, int offset, int number, string &ret) {
	string ret_str_tmp;
	string ret_str;
	int ret_int;
	int position, new_pos;

	position = extract_word(mem, offset, ret_str_tmp);
	if (position == 0) {
		return(0);
	}
	ret_str = ret_str_tmp;

	new_pos = position;
	for (int i = 1; i < number; i++) {
		new_pos = extract_word(mem, new_pos, ret_str_tmp);
		if (new_pos != 0) {
			ret_str.append(" ");
			ret_str.append(ret_str_tmp);
		}
	}

	ret = ret_str;
	return(position);
}

/*
* Converts a character array to a integer
*/
int Charactertools::Character_To_Int(char *c, int size) {
	int ret = 0;
	int j = 0;
	for (int i = size - 1; i >= 0; i--) {
		ret = ret + (c[i] << 8 * j);
		j++;
	}
	return(ret);
}

/*
* Converts a Integer to character array
* The out array must be +1 larger than size because of stop character 0x00
*/
void Charactertools::Int_To_Character(char *out, int in, int size) {
	int j = size - 1;
	for (int i = 0; i <= size - 1; i++) {
		out[j] = (char)(in >> 8 * i);
		j--;
	}
	out[size] = '\0';
}